%define module_name P
# BEGIN SourceDeps(oneline):
BuildRequires: perl(ExtUtils/MakeMaker.pm) perl(PerlIO.pm) perl(Test/Simple.pm) perl(Types/Core.pm) perl(Xporter.pm) perl(mem.pm) perl(version.pm)
# END SourceDeps(oneline)
%define _unpackaged_files_terminate_build 1
BuildRequires: rpm-build-perl perl-devel perl-podlators

Name: perl-%module_name
Version: 1.1.40
Release: alt1
Summary: safer+easier [s]print[f], & say all-in-1
Group: Development/Perl
License: perl
Url: %CPAN %module_name

Source0: http://mirror.yandex.ru/mirrors/cpan/authors/id/L/LA/LAWALSH/%{module_name}-%{version}.tar.gz
BuildArch: noarch

%description
`P' is a combined printf, sprintf & say in 1 routine.  It was designed
to save on typing and undef checking when printing strings.  It saves on
in that you don't have constantly insert or move `newline's (`\n').  
If you change a string into a formatted string, insert P, as in:

  die "Wrong number of params";
             # to
  die P "Expecting 2 params, got %%s", scalar @ARGV;


When printed as
strings (`"%%s"'), undefs are automatically caught and "E<0x2204>", (U+2204 - 
meaning "*There does not exist*") is
printed in place of "`Use of uninitialized value $x in xxx at -e line z.'"

By default `P', prints the content of references (instead HASH 
(or ARRAY)=(0x12345678), three levels deep.  Deeper nesting is replaced
by the unicode ellipsis character (U+2026).

While designed for development use, it is useful in many more situations, as 
tries to "do the right thing" based on context.  It can usually be used
as a drop-in replacement the perl functions `print', `printf', `sprintf',
and, `say'.  

P tries to smartly handle newlines at the end of the line -- adding them 
or subtracting them based on if they are going to a file handle or to another
variable.

The newline handling at the end of a line can be supressed by adding
the Unicode control char "Don't break here" (0x83) at the end of a string
or by assigning the return value and having a file handle as the first
argument.  Ex: `my $fmt = P STDOUT, "no LF added here-->"'.


`Bless'ed objects, by default,  are printed with the Class or package name
in front of the reference.   Note that these substitutions are performed only with 
references printed through a string (`"%%s"') format -- features designed
to give useful output in development or debug situations.

One minor difference between `P' and `sprintf': `P' can take 
an array with the format in the 0th element, and parameters following.  
`Sprintf' will cause an error to be raised, if you try passing an array
to it, as it will force the array into scalar context -- which as 
the manpage says "is almost never useful".  Rather than follow in the
design flaws of its predecessors, P *tries* to do the right thing.


NOTE: A side effect of P being a contextual replacement for sprintf,
is if it is used as the last line of a subroutine.  By default, this
won't print it's arguments to STDOUT unless you explicity specify the
filehandle, as it will think it is supposed to return the result -- not
print it.

%prep
%setup -q -n %{module_name}-%{version}

%build
%perl_vendor_build

%install
%perl_vendor_install

%files
%doc README Changes LICENSE
%perl_vendor_privlib/P*

%changelog
* Thu Feb 21 2019 Igor Vlasenko <viy@altlinux.ru> 1.1.40-alt1
- updated by package builder

* Thu May 26 2016 Igor Vlasenko <viy@altlinux.ru> 1.1.37-alt1
- regenerated from template by package builder

* Tue May 03 2016 Igor Vlasenko <viy@altlinux.ru> 1.1.34-alt1
- regenerated from template by package builder

* Thu Apr 07 2016 Igor Vlasenko <viy@altlinux.ru> 1.1.32-alt1
- regenerated from template by package builder

* Fri Mar 04 2016 Igor Vlasenko <viy@altlinux.ru> 1.1.31-alt1
- regenerated from template by package builder

* Fri Feb 19 2016 Igor Vlasenko <viy@altlinux.ru> 1.1.29-alt1
- regenerated from template by package builder

* Tue Dec 15 2015 Igor Vlasenko <viy@altlinux.ru> 1.1.28-alt1
- regenerated from template by package builder

* Wed Oct 14 2015 Igor Vlasenko <viy@altlinux.ru> 1.1.27-alt1
- regenerated from template by package builder

* Tue May 06 2014 Igor Vlasenko <viy@altlinux.ru> 1.1.24-alt1
- regenerated from template by package builder

* Tue Dec 17 2013 Igor Vlasenko <viy@altlinux.ru> 1.1.17-alt1
- regenerated from template by package builder

* Wed Nov 20 2013 Igor Vlasenko <viy@altlinux.ru> 1.1.16-alt1
- regenerated from template by package builder

* Wed Sep 04 2013 Igor Vlasenko <viy@altlinux.ru> 1.0.20-alt1
- initial import by package builder

